/* 
    Koch_Fractal_Geometry.ino - 
    Draw the Koch's Snowflake
   Claudio Gasparini - www.cad-tutor.com/alvik 
*/

#include "Arduino_Alvik.h"

Arduino_Alvik alvik;

int depth = 3;  // Depth of the curve (increase for more detail)
float step_size = 4.0; // Base segment length
float spacing = 88.0; // Distance between fractals


void setup() {
  while ((!Serial) && (millis() < 3000));
  alvik.begin();
}

void koch(int level, float length) {
  if (level == 0) {
    // Basic movement: move forward by "length"
    alvik.set_wheels_speed(50, 50); 
    delay(length * 10); // Time proportional to length
    alvik.set_wheels_speed(0, 0);
  } else {
     // Recursion: divide the segment into 4 sub-segments
    koch(level - 1, length / 3.0);
    
    // Rotate left by 60°
   alvik.set_wheels_speed(-50, 50);
    delay(200);
    alvik.set_wheels_speed(0, 0);
    
    koch(level - 1, length / 3.0);
    
    // Rotate right by 120°
    alvik.set_wheels_speed(50, -50);
    delay(300);
    alvik.set_wheels_speed(0, 0);
    
    koch(level - 1, length / 3.0);
    
     // Rotate left by 60°
    alvik.set_wheels_speed(-50, 50);
    delay(300);
    alvik.set_wheels_speed(0, 0);
    
    koch(level - 1, length / 3.0);
  }
}

void loop() {
  for (int i = 0; i < 5; i++) { // Draw the curve 5 times
    koch(depth, step_size * pow(3, depth)); 
    delay(500); // Pause between curves

    // PAUSE to change the pen
    Serial.println("Cambia la penna ora!");
    delay(5000); // Wait for 5 seconds (you can increase)

    // Move the robot forward to increase the distance between fractals
    alvik.set_wheels_speed(80, 80); // Velocità alta per avanzare
    delay(spacing); // Usa "spacing" per determinare la distanza
    alvik.set_wheels_speed(0, 0);
    
    // Rotate to reposition
    alvik.set_wheels_speed(-50, 50);
    delay(350);
    alvik.set_wheels_speed(0, 0);
  }
  
  while (true); // Stop the robot at the end
}
